local commonharbour, CommonHarbourPrefix, ModelsPath, ScriptsPath = ...

--------------------------------------------------------------------------
-- Apply building asset processor
commonharbour:registerAssetProcessor(ModelsPath .. "/lightTower.fbx", {
	DataType = "BUILDING_ASSET_PROCESSOR"
})

-- Register light house prefab nodes
commonharbour:registerAssetId(ModelsPath .. "/lightTower.fbx/Prefab/LightTowerPart", CommonHarbourPrefix .. "_LIGHT_TOWER_PREFAB")

-- Register the light tower root part
commonharbour:register({
	DataType = "BUILDING_PART",
	Id = CommonHarbourPrefix .. "_LIGHT_TOWER_PART",
	Name = CommonHarbourPrefix .. "_LIGHT_TOWER_NAME",
	Description = CommonHarbourPrefix .. "_LIGHT_TOWER_DESC",
	Category = "CORE",
        BuildingZone = _LightTowerBuildingZone,
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = CommonHarbourPrefix .. "_LIGHT_TOWER_PREFAB",
                IsPreviewGroundVisible = true
	},
	Cost = {
		UpkeepCost = {
			{ Resource = "GOLD", Quantity = _NoSandbox*0 }
		},
		RessourcesNeeded = { -- List of RESOURCE_QUANTITY_PAIR
			{ Resource = "STONE", Quantity = _NoSandbox*25 },
			{ Resource = "POLISHED_STONE", Quantity = _NoSandbox*20 },
			{ Resource = "WOOD", Quantity = _NoSandbox*15 },
			{ Resource = "PLANK", Quantity = _NoSandbox*10 },
			{ Resource = "TOOL", Quantity = _NoSandbox*5 },
		}
	}})

--------------------------------------------------------------------------
-- Register grass clearing components
commonharbour:registerPrefabComponent(ModelsPath .. "/lightTower.fbx/Prefab/LightTowerPart", {
	DataType = "COMP_DIRT_CIRCLE",
	HardRadius = 4,
        SoftRadius = 4,
        IsPermanent = true
})
function registerSmoke(_number)
    -- Register particle system
    commonharbour:registerAssetId(ModelsPath .. "/lightTower.fbx/Prefab/LightTowerPart/smokeLocator" .. _number, CommonHarbourPrefix .. "_SMOKE_LOCATOR_" .. _number .. "_PREFAB")

    commonharbour:registerPrefabComponent(ModelsPath .. "/lightTower.fbx/Prefab/LightTowerPart/smokeLocator" .. _number, {
	DataType = "COMP_PARTICLE_EMITTER",
	ParticleSystem = "PARTICLE_SYSTEM_BLACKSMITH_FIRE_SMOKE",
	IsPlaying = true,
	IsEmitting = true
    })

    commonharbour:registerPrefabComponent(ModelsPath .. "/lightTower.fbx/Prefab/LightTowerPart/smokeLocator" .. _number, {
	DataType = "COMP_PARTICLE_EMITTER_TOGGLE",
	Enabled = true
    })
end
registerSmoke("1")
registerSmoke("2")

-- Register particle system
commonharbour:registerAssetId(ModelsPath .. "/lightTower.fbx/Prefab/LightTowerPart/rotateOven/fireLocator", CommonHarbourPrefix .. "_FIRE_LOCATOR_PREFAB")

commonharbour:registerPrefabComponent(ModelsPath .. "/lightTower.fbx/Prefab/LightTowerPart/rotateOven/fireLocator", {
	DataType = "COMP_PARTICLE_EMITTER",
	ParticleSystem = "PARTICLE_SYSTEM_BLACKSMITH_FIRE",
	IsPlaying = true,
	IsEmitting = true
})

-- Components
commonharbour:dofile(ScriptsPath .. "/compRotateOven.lua", CommonHarbourPrefix)

commonharbour:registerAssetId(ModelsPath .. "/lightTower.fbx/Prefab/LightTowerPart/rotateOven", CommonHarbourPrefix .. "_ROTATE_OVEN_PREFAB")

-- Register wheel component
commonharbour:registerPrefabComponent(ModelsPath .. "/lightTower.fbx/Prefab/LightTowerPart/rotateOven", {
	    DataType = CommonHarbourPrefix .. "_COMP_ROTATE_OVEN",
	    Enabled = true,
    })

commonharbour:registerPrefabComponent(ModelsPath .. "/lightTower.fbx/Prefab/LightTowerPart", {
	DataType = "COMP_BUILDING_PART",
	FeedbackComponentListToActivate = {
		{ CommonHarbourPrefix .. "_SMOKE_LOCATOR_1_PREFAB", "COMP_PARTICLE_EMITTER_TOGGLE" },
		{ CommonHarbourPrefix .. "_SMOKE_LOCATOR_2_PREFAB", "COMP_PARTICLE_EMITTER_TOGGLE" },
		{ CommonHarbourPrefix .. "_FIRE_LOCATOR_PREFAB", "COMP_PARTICLE_EMITTER_TOGGLE" },
		{ CommonHarbourPrefix .. "_ROTATE_OVEN_PREFAB", CommonHarbourPrefix .. "_COMP_ROTATE_OVEN" }
	}
})


